-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>=7 then
lib.classes["DRUID"] = {}
local t,s
lib.classes["DRUID"][10] = function()
	lib.AddSpell("Wrath",{5176}) -- Wrath
	cfg.gcd_spell = "Wrath"
	lib.AddSpell("Starfire",{2912}) -- Starfire
	lib.AddSpell("Moonfire",{8921}) -- Moonfire
	lib.AddSpell("Starsurge",{78674}) -- Starsurge
	lib.AddSpell("IS",{5570}) -- Insect Swarm
	lib.AddSpell("Inner",{29166}) -- Innervate
	
	lib.AddAura("Moonfire",8921,"debuff","target") -- Moonfire
	lib.AddAura("Sunfire",93402,"debuff","target") -- Sunfire
	lib.AddAura("IS",5570,"debuff","target") -- Moonfire
	lib.AddAura("Solar",48517,"buff","player") -- Solar
	lib.AddAura("SS",93400,"buff","player") -- Shooting Stars
	lib.AddAura("Lunar",48518,"buff","player") -- Lunar
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Starsurge_SS")
	table.insert(cfg.plistdps,"IS_noIS")
	table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	table.insert(cfg.plistdps,"Starsurge")
	table.insert(cfg.plistdps,"Starfire")
	table.insert(cfg.plistdps,"Wrath")
	table.insert(cfg.plistdps,"Inner")
	table.insert(cfg.plistdps,"end")
	cfg.plist=cfg.plistdps
	
	cfg.case = {
		["Moonfire_noMoonfire"] = function ()
			if lib.GetAura({"Moonfire","Sunfire"})-lib.GetSpellCD(cfg.gcd_spell)<2 then
				return lib.SimpleCDCheck("Moonfire")
			end
			return nil
		end,
		["IS_noIS"] = function ()
			if lib.GetAura({"IS"})-lib.GetSpellCD(cfg.gcd_spell)<2 then
				return lib.SimpleCDCheck("IS")
			end
			return nil
		end,
		["Starsurge"] = function ()
			if not lib.SpellCasting("Starsurge") or lib.GetAura({"SS"})>0 then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
		["Starsurge_SS"] = function ()
			if lib.GetAura({"SS"})>0 then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
		["Wrath"] = function ()
			if lib.GetAura({"Solar"})>0 then 
				return lib.SimpleCDCheck("Wrath")
			elseif lib.GetAura({"Lunar"})==0 and cfg.eclipse<=0 then
				if cfg.eclipse>-85 then
					return lib.SimpleCDCheck("Wrath")
				elseif cfg.eclipse<=-85 and lib.SpellCasting("Starsurge") then
					return lib.SimpleCDCheck("Starfire")
				elseif cfg.eclipse<=-87 and lib.SpellCasting("Wrath") then
					return lib.SimpleCDCheck("Starfire")
				end
				return lib.SimpleCDCheck("Wrath")
			end
			return nil
		end,
		["Starfire"] = function ()
			if lib.GetAura({"Lunar"})>0 then
				return lib.SimpleCDCheck("Starfire")
			elseif lib.GetAura({"Solar"})==0 and cfg.eclipse>0 then
				if cfg.eclipse<80 then
					return lib.SimpleCDCheck("Starfire")
				elseif cfg.eclipse>=80 and lib.SpellCasting("Starfire") then
					return lib.SimpleCDCheck("Wrath")
				elseif cfg.eclipse>=85 and lib.SpellCasting("Starsurge") then
					return lib.SimpleCDCheck("Wrath")
				end
				return lib.SimpleCDCheck("Starfire")
			end
			return nil
		end,
	}
	
	lib.rangecheck=function()
		if lib.inrange("Wrath") then
			lib.bdcolor(Heddmain.bd,nil)
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end
	
	cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
	
	lib.myonpower=function(unit,powerType)
		if unit=="player" and powerType == 'ECLIPSE' then
			cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
			cfg.Update=true
		end
	end
	return true
end

lib.classes["DRUID"][3] = function() --Bear
	lib.SetSpellIcon("aa","Interface\\Icons\\Ability_Druid_CatFormAttack",true)
	lib.SetPower("RAGE")
	lib.AddResourceBar(cfg.Power.max)
	lib.ChangeResourceBarType(cfg.Power.type)
	
	lib.AddSpell("Mangle",{33917}) -- Mangle
	--lib.AddAura("Regrowth",145162,"buff","player") -- Dream of Cenarius
	lib.AddSpell("Moonfire",{8921})
	--lib.FixSpell("Moonfire","cost")
	lib.AddAura("Moonfire",164812,"debuff","target")
	lib.AddAura("Galactic Guardian",213708,"buff","player")
	
	--lib.AddSpell("Pulverize",{80313}) -- Pulverize
	--lib.AddAura("Pulverize",158792,"buff","player") -- Pulverize
	--lib.SetTrackAura("Pulverize")
	lib.AddSpell("Thrash",{77758},"target")
	lib.AddAura("Thrash",192090,"debuff","target")
	lib.AddCleaveSpell("Thrash",nil,{77758,192090})
	
	lib.AddSpell("Swipe",{213764,213771})
	lib.AddCleaveSpell("Swipe")
	lib.SetDOT("Thrash")
	lib.AddSpell("Maul",{6807}) -- Maul
	--lib.AddAura("TaC",135286,"buff","player") -- Tooth and Claw
	lib.AddSpell("Bear",{5487}) -- Bear Form
	lib.AddSpell("Frenzied Regeneration",{22842},true) -- Frenzied Regeneration
	lib.AddSpell("Ironfur",{192081},true)
	lib.AddSpell("Mark of Ursol",{192083},true)
	lib.AddSpell("Rage of the Sleeper",{200851},true)
	--lib.AddSpell("Defense",{62606}) -- Savage Defense
	--lib.AddAura("Defense",132402,"buff","player") -- Savage Defense
	lib.AddSpell("Barkskin",{22812},true) -- Barkskin
	lib.AddSpell("Instincts",{61336},true) -- Survival Instincts
	lib.SetTrackAura({"Galactic Guardian","Instincts","Rage of the Sleeper","Barkskin","Ironfur","Mark of Ursol"})

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Bear_noBear")
	table.insert(cfg.plistdps,"Ironfur")
	table.insert(cfg.plistdps,"Mark of Ursol")
	table.insert(cfg.plistdps,"Frenzied Regeneration")
	table.insert(cfg.plistdps,"Moonfire_range")
	table.insert(cfg.plistdps,"Moonfire_Galactic Guardian")
	table.insert(cfg.plistdps,"Rage of the Sleeper")
	table.insert(cfg.plistdps,"Thrash_aoe")
	table.insert(cfg.plistdps,"Mangle")
	table.insert(cfg.plistdps,"Thrash")
	table.insert(cfg.plistdps,"Swipe_aoe")
	table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	table.insert(cfg.plistdps,"Swipe")
	table.insert(cfg.plistdps,"Maul_nocap")
	table.insert(cfg.plistdps,"Ironfur_nocap")
	table.insert(cfg.plistdps,"Ursol_nocap")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = nil
	cfg.case = {
		["Moonfire_range"] = function()
			if lib.inrange("Mangle") then return nil end
			return lib.SimpleCDCheck("Moonfire",lib.GetAura({"Moonfire"})-4.2)
		end,
		["Moonfire_noMoonfire"] = function()
			return lib.SimpleCDCheck("Moonfire",lib.GetAura({"Moonfire"})-4.2)
		end,
		["Thrash_aoe"] = function()
			if cfg.cleave_targets>=2 then
				return lib.SimpleCDCheck("Thrash")
			end
			return nil
		end,
		["Swipe_aoe"] = function()
			if cfg.cleave_targets>=4 then
				return lib.SimpleCDCheck("Swipe")
			end
			return nil
		end,
		["Moonfire_Galactic Guardian"] = function()
			if lib.GetAura({"Galactic Guardian"})>lib.GetSpellCD("Moonfire") then
				return lib.SimpleCDCheck("Moonfire")
			end
			return nil
		end,
		["Bear_noBear"] = function()
			if cfg.shape.name~="Bear" then
				return lib.SimpleCDCheck("Bear")
			end
			return nil
		end,
		["Defense_HP"] = function()
			if cfg.Power.now>=60 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Defense",lib.GetAura({"Defense"}))
			end
		end,
		["Frenzied Regeneration"] = function()
			if cfg.Power.now>=10 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Frenzied Regeneration",lib.GetAura({"Frenzied Regeneration"}))
			end
		end,
		["Ironfur"] = function()
			if cfg.Power.now>=45 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Ironfur")
			end
		end,
		["Mark of Ursol"] = function()
			if cfg.Power.now>=45 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Mark of Ursol",lib.GetAura({"Mark of Ursol"}))
			end
		end,
		["Maul_nocap"] = function()
			if cfg.Power.now>=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Maul")
			end
			return nil
		end,
		["Ironfur_nocap"] = function()
			if cfg.Power.now>=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Ironfur")
			end
			return nil
		end,
		["Ursol_nocap"] = function()
			if cfg.Power.now>=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Ursol")
			end
			return nil
		end,
	}
	
	cfg.plist=cfg.plistdps
	lib.SetInterrupt("Kick",{106839})
	
	lib.AddRangeCheck({
	{"Mangle",nil},
	{"Kick",{0,0,1,1}},
	{"Moonfire",{1,1,0,1}},
	})
	
	return true
end

lib.classes["DRUID"][2] = function() --Cat
	cfg.Cat={}
	cfg.Cat.Rip={}
	cfg.Cat.Rake={}
	lib.OnTargetChanged=function()
		cfg.Cat.Rip[cfg.GUID["target"]]=cfg.Cat.Rip[cfg.GUID["target"]] or 0
		if cfg.Cat.Rip[cfg.GUID["target"]]>0 then
			Heddmain.info:SetText(math.floor(cfg.Cat.Rip[cfg.GUID["target"]]*100).."%") 
		else
			Heddmain.info:SetText("")
		end
		cfg.Cat.Rake[cfg.GUID["target"]]=cfg.Cat.Rake[cfg.GUID["target"]] or 0
		if cfg.Cat.Rake[cfg.GUID["target"]]>0 then
			Heddmain.info_DOT:SetText(math.floor(cfg.Cat.Rake[cfg.GUID["target"]]*100).."%")
		else
			Heddmain.info_DOT:SetText("")
		end
	end
	cfg.talents={
		["Bloodtalons"]=IsPlayerSpell(155672),
		["Lunar Inspiration"]=IsPlayerSpell(155580),
		["Sabertooth"]=IsPlayerSpell(202031),
		["Jagged Wounds"]=IsPlayerSpell(202032),
		["Incarnation: King of the Jungle"]=IsPlayerSpell(102543),
		["Brutal Slash"]=IsPlayerSpell(202028),
		["Savage Roar"]=IsPlayerSpell(52610),
	}
	if cfg.talents["Sabertooth"] then
		cfg.cat_rip=0
	else
		cfg.cat_rip=24*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
		lib.OnUpdateHealth = function(unitID)
			if unitID=="target" then
				if cfg.health[unitID].percent>25 or cfg.health[unitID].percent==0 then
					cfg.cat_rip=24*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
				else
					cfg.cat_rip=0
				end
			end
		end
	end
	if cfg.talents["Bloodtalons"] then
		lib.AddAura("Predatory Swiftness",69369,"buff","player")
		lib.AddAura("Bloodtalons",145152,"buff","player")
	end
	
	cfg.cat_rake=12*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
	cfg.cat_roar=24*0.3
	cfg.cat_thrash=15*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
	
	cfg.cleave_threshold=3
	lib.SetSpellIcon("aa","Interface\\Icons\\Ability_Druid_CatFormAttack",true)
	lib.SetPower("ENERGY")
	lib.SetAltPower("COMBO_POINTS")
	cfg.set["T13"]={}
	cfg.set["T13"]={77013,77014,77015,77016,77017,78743,78665,78713,78694,78684,78838,78760,78808,78789,78779}
	lib.AddSpell("Rejuvenation",{774},true) -- Rejuvenation
	lib.AddSpell("Rake",{1822}) -- Rake
	lib.AddSpell("Berserk",{102543,106951},true)
	lib.AddSpell("Elune's Guidance",{202060},true)
	lib.AddAura("Rake",155722,"debuff","target") -- Rake
	lib.SetDOT("Rake",3)
	lib.SetAuraFunction("Rake","OnFade",function(num_func,spell)
		cfg.Cat.Rake[cfg.GUID["target"]]=0
		Heddmain.info_DOT:SetText("")
	end)
	lib.AddSpell("Shred",{5221}) -- Shred
	lib.AddSpell("Ashamane's Frenzy",{210722})
	lib.AddSpell("Savage Roar",{52610},true) -- Savage Roar
	lib.AddSpell("Rip",{1079},"target") -- Rip
	lib.SetAuraFunction("Rip","OnFade",function(num_func,spell)
		cfg.Cat.Rip[cfg.GUID["target"]]=0
		Heddmain.info:SetText("")
	end)
	cfg.Cat.Buffs_Rip ={
	["Tiger's Fury"]=1.15,
	["Bloodtalons"]=1.50,
	["Savage Roar"]=1.25,
	["Berserk"]=1.15
	}
	cfg.Cat.Buffs_Rake ={
	["Tiger's Fury"]=1.15,
	["Bloodtalons"]=1.50,
	["Savage Roar"]=1.25,
	["Berserk"]=1.15,
	["Prowl"]=2
	}
	lib.OnSpellCast("Rip",function()
		cfg.Cat.Rip[cfg.GUID["target"]]=lib.AurasCount(cfg.Cat.Buffs_Rip,true)
		if cfg.Cat.Rip[cfg.GUID["target"]]>0 then
			Heddmain.info:SetText(math.floor(cfg.Cat.Rip[cfg.GUID["target"]]*100).."%") 
		else
			Heddmain.info:SetText("")
		end
	end)
	lib.OnSpellCast("Rake",function()
		cfg.Cat.Rake[cfg.GUID["target"]]=lib.AurasCount(cfg.Cat.Buffs_Rake,true)
		if cfg.Cat.Rake[cfg.GUID["target"]]>0 then
			Heddmain.info_DOT:SetText(math.floor(cfg.Cat.Rake[cfg.GUID["target"]]*100).."%")
		else
			Heddmain.info_DOT:SetText("")
		end
	end)
	if cfg.talents["Lunar Inspiration"] then
		lib.AddSpell("Moonfire",{8921}) -- Moonfire
		lib.AddAura("Moonfire",155625,"debuff","target") -- Moonfire
		lib.FixSpell("Moonfire","cost")
		lib.OnSpellCast("Cat",function()
			lib.ReloadSpell("Moonfire")
			lib.FixSpell("Moonfire","cost")
			end)
	end
	lib.AddSpell("Ferocious Bite",{22568}) -- Ferocious Bite
	lib.AddSpell("Tiger's Fury",{5217},true) -- Tiger's Fury
	lib.AddSpell("Charge",{49376}) -- Feral Charge
	lib.AddSpell("Thrash",{106832})
	lib.FixSpell("Thrash","cost")
	--lib.ChangeSpellID("Thrash",106830,true)
	lib.AddAura("Thrash",106830,"debuff","target")
	lib.AddCleaveSpell("Thrash",nil,{106830})
	if cfg.talents["Brutal Slash"] then
		lib.AddSpell("Brutal Slash",{202028})
		lib.FixSpell("Brutal Slash","cost")
		lib.AddCleaveSpell("Brutal Slash")
	else
		lib.AddSpell("Swipe",{213764,106785})
		lib.FixSpell("Swipe","cost")
		lib.AddCleaveSpell("Swipe",nil,{213764,106785})
	end
	lib.AddSpell("Cat",{768})
	
	lib.AddAura("Clearcasting",135700,"buff","player")
	--lib.AddAuras("Prowl",{5215},"buff","player")
	lib.AddSpell("Prowl",{5215},true)
	lib.AddSpell("Regrowth",{8936},true)
	lib.SetTrackAura({"Bloodtalons","Predatory Swiftness","Clearcasting"})
	lib.AddSpell("Instincts",{61336},true) -- Survival Instincts
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	--table.insert(cfg.plistdps,"Regrowth_Instant")
	if cfg.talents["Bloodtalons"] then
		table.insert(cfg.plistdps,"Regrowth_Bloodtalons_nocombat")
	end
	table.insert(cfg.plistdps,"Cat_noCat")
	table.insert(cfg.plistdps,"Prowl_nocombat")
	table.insert(cfg.plistdps,"Savage Roar_nocombat")
	table.insert(cfg.plistdps,"Rake_Prowl")
	if cfg.talents["Bloodtalons"] then
		table.insert(cfg.plistdps,"Regrowth_Bloodtalons_proc")
	end
	table.insert(cfg.plistdps,"Berserk_TF")
	table.insert(cfg.plistdps,"TF_40")
	if cfg.talents["Bloodtalons"] then
		table.insert(cfg.plistdps,"Regrowth_Bloodtalons_max")
	end
	table.insert(cfg.plistdps,"Ferocious Bite_Rip")
	table.insert(cfg.plistdps,"Savage Roar_noSavage Roar")
	table.insert(cfg.plistdps,"Rip_noRip")
	table.insert(cfg.plistdps,"Savage Roar_noSavage Roar_renew")
	table.insert(cfg.plistdps,"FB_5")
	table.insert(cfg.plistdps,"Elune's Guidance")
	table.insert(cfg.plistdps,"Rake_noRake")
	table.insert(cfg.plistdps,"Thrash_noThrash_aoe")
	if cfg.talents["Brutal Slash"] then
		table.insert(cfg.plistdps,"Brutal Slash_aoe")
		table.insert(cfg.plistdps,"Rake_noRake_aoe")
	else
		table.insert(cfg.plistdps,"Rake_noRake_aoe")
		table.insert(cfg.plistdps,"Swipe_aoe")
	end
	
	if cfg.talents["Lunar Inspiration"] then
		table.insert(cfg.plistdps,"Moonfire_range")
	end
	table.insert(cfg.plistdps,"Ashamane's Frenzy")
	if cfg.talents["Lunar Inspiration"] then
		table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	end
	if cfg.talents["Brutal Slash"] then
		table.insert(cfg.plistdps,"Brutal Slash_single")
	end
	table.insert(cfg.plistdps,"Shred_nomax")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	cfg.plistaoe=nil

	cfg.case = {
		["Thrash_Bloodtalons_aoe"] = function()
			if cfg.cleave_targets>=cfg.cleave_threshold then
				if cfg.AltPower.now==0 and lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Thrash") then
					return lib.SimpleCDCheck("Thrash")
				end
			end
			return nil
		end,
		["Thrash_noThrash_aoe"] = function()
			if cfg.cleave_targets>=cfg.cleave_threshold then
				return lib.SimpleCDCheck("Thrash",lib.GetAura({"Thrash"})-cfg.cat_thrash)
			end
			return nil
		end,
		["Swipe_aoe"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.cleave_targets>=cfg.cleave_threshold then
				if lib.GetSpellCost("Swipe")<45 then
					return lib.SimpleCDCheck("Swipe")
				else
					return lib.SimpleCDCheck("Swipe",lib.Time2Power(50))
				end
			end
			return nil
		end,
		["Brutal Slash_aoe"] = function()
			if cfg.cleave_targets>=2 and cfg.AltPower.now<cfg.AltPower.max then
				return lib.SimpleCDCheck("Brutal Slash")
			end
			return nil
		end,
		["Rake_Prowl"] = function()
			if lib.GetAura("Prowl")>0 then
				return lib.SimpleCDCheck("Rake")
			end
			return nil
		end,
		["Savage Roar_nocombat"] = function()
			if cfg.combat then return nil end
			if cfg.AltPower.now>0 then
				return lib.SimpleCDCheck("Savage Roar",lib.GetAura({"Savage Roar"}))
			end
			return nil
		end,
		["Prowl_nocombat"] = function()
			if cfg.combat then return nil end
			return lib.SimpleCDCheck("Prowl",lib.GetAura("Prowl"))
		end,
		["Regrowth_Bloodtalons_nocombat"] = function()
			if lib.SpellCasting("Regrowth") or cfg.combat or lib.GetAura("Prowl")>0 then return nil end
			if lib.GetAuraStacks("Bloodtalons")<2 then
				return lib.SimpleCDCheck("Regrowth")
			else
				return lib.SimpleCDCheck("Regrowth",lib.GetAura({"Bloodtalons"}))
			end
		end,
		["Regrowth_Bloodtalons_max"] = function()
			if lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") and cfg.AltPower.now==cfg.AltPower.max then
				return lib.SimpleCDCheck("Regrowth")
			end
			return nil
		end,
		["Regrowth_Instant"] = function()
			if lib.GetUnitHealth("player","percent")<=70 and lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
				return lib.SimpleCDCheck("Regrowth")
			end
			return nil
		end,
		["Regrowth_Bloodtalons_proc"] = function()
			if lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
				return lib.SimpleCDCheck("Regrowth",lib.GetAura({"Predatory Swiftness"})-cfg.gcd*1.5)
			end
			return nil
		end,
		["Regrowth_Bloodtalons_aoe"] = function()
			if lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
				return lib.SimpleCDCheck("Regrowth")
			end
			return nil
		end,
		["Cat_noCat"] = function()
			if cfg.shape.name~="Cat" then
				return lib.SimpleCDCheck("Cat")
			end
			return nil
		end,
		["Thrash_noThrash"] = function()
			return lib.SimpleCDCheck("Thrash",lib.GetAura({"Thrash"})-4.5)
		end,
		["Rake_Bloodtalons"] = function()
			if cfg.noaoe or cfg.cleave_targets<cfg.cleave_threshold then
				if cfg.AltPower.now==0 and lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Rake") then
					if cfg.Cat.Rake[cfg.GUID["target"]]<lib.AurasCount(cfg.Cat.Buffs_Rake) then
						return lib.SimpleCDCheck("Rake")
					end
				end
			end
			return nil
		end,
		["Rake_noRake"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe or cfg.cleave_targets<=3 then
				if cfg.Cat.Rake[cfg.GUID["target"]]<lib.AurasCount(cfg.Cat.Buffs_Rake) then
					return lib.SimpleCDCheck("Rake")
				elseif cfg.Cat.Rake[cfg.GUID["target"]]==lib.AurasCount(cfg.Cat.Buffs_Rake) then
					return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"})-cfg.cat_rake)
				else
					return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"}))
				end
			end
			return nil
		end,
		["Rake_noRake_aoe"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.cleave_targets>3 and cfg.cleave_targets<=8 then
				return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"}))
			end
			return nil
		end,
		--[[["Ashamane's Frenzy"] = function()
			if cfg.AltPower.now>cfg.AltPower.max-3 then return nil end
			if lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Ashamane's Frenzy") then
				return lib.SimpleCDCheck("Ashamane's Frenzy")
			end
			return nil
		end,]]
		["Ashamane's Frenzy"] = function()
			if cfg.AltPower.now>cfg.AltPower.max-3 then return nil end
			if lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Ashamane's Frenzy") then
				if not cfg.talents["Bloodtalons"] or (cfg.talents["Bloodtalons"] and lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Ashamane's Frenzy")) then
					if not cfg.talents["Savage Roar"] or (cfg.talents["Savage Roar"] and lib.GetAura({"Savage Roar"})>lib.GetSpellCD("Ashamane's Frenzy")) then
						return lib.SimpleCDCheck("Ashamane's Frenzy")
					end
				end
			end
			return nil
		end,
		["Elune's Guidance"] = function()
			if cfg.AltPower.now==0 and cfg.Power.now<cfg.Power.max then
				return lib.SimpleCDCheck("Elune's Guidance")
			end
		end,
		
		["Shred_nomax"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe or cfg.cleave_targets<cfg.cleave_threshold then
				if lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Shred") and lib.GetAura({"Clearcasting"})>lib.GetSpellCD("Shred") then
					return lib.SimpleCDCheck("Shred",lib.Time2Power(lib.GetSpellCost("Rake")))
				else
					return lib.SimpleCDCheck("Shred")
				end
			else
				return lib.SimpleCDCheck("Shred",lib.Time2Power(50))
			end
		end,
		["Brutal Slash_nomax"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			return lib.SimpleCDCheck("Brutal Slash")
		end,
		["Brutal Slash_single"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe then
				return lib.SimpleCDCheck("Brutal Slash")
			end
			return nil
		end,
		["Swipe"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			return lib.SimpleCDCheck("Swipe")
		end,
		["Savage Roar_noSavage Roar"] = function()
			if (cfg.talents["Bloodtalons"] and cfg.AltPower.now==cfg.AltPower.max) or (not cfg.talents["Bloodtalons"] and cfg.AltPower.now>0) then
				return lib.SimpleCDCheck("Savage Roar",lib.GetAura({"Savage Roar"}))
			end
			return nil
		end,
		
		["Savage Roar_noSavage Roar_renew"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then
				return lib.SimpleCDCheck("Savage Roar",lib.GetAura({"Savage Roar"})-cfg.cat_roar)
			end
			return nil
		end,
		["Moonfire_noMoonfire"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe or cfg.cleave_targets<cfg.cleave_threshold then
				return lib.SimpleCDCheck("Moonfire",math.max(lib.GetAura({"Moonfire"})-4.2,lib.Time2Power(lib.GetSpellCost("Rake"))))
			end
			return nil
		end,
		["Moonfire_range"] = function()
			if lib.inrange("Rake") then return nil end
			return lib.SimpleCDCheck("Moonfire",math.max(lib.GetAura({"Moonfire"})-4.2,lib.GetAura("Prowl")))
		end,
		
		["Rip_noRip"] = function()
			if cfg.AltPower.now<5 then return nil end
			if cfg.Cat.Rip[cfg.GUID["target"]]<lib.AurasCount(cfg.Cat.Buffs_Rip) then
				return lib.SimpleCDCheck("Rip")
			end
			if cfg.talents["Savage Roar"] then
				if lib.GetAura({"Savage Roar"})>lib.GetSpellCD("Rip") and lib.GetAura({"Savage Roar"})>lib.GetAura({"Rip"})-cfg.cat_rip then
					return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-cfg.cat_rip)
				end
			else
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-cfg.cat_rip)
			end
			return nil
		end,
		["FB_5"] = function()
			if cfg.AltPower.now>=5 then
				if lib.GetAura({"Berserk"})>lib.Time2Power(25+lib.GetSpellCost("Ferocious Bite")) then
					return lib.SimpleCDCheck("Ferocious Bite",lib.Time2Power(25+lib.GetSpellCost("Ferocious Bite")))
				end
				return lib.SimpleCDCheck("Ferocious Bite",lib.Time2Power(cfg.Power.max))
			end
			return nil
		end,
		["Ferocious Bite_Rip"] = function()
			if lib.GetUnitHealth("target","percent")<25 or cfg.talents["Sabertooth"] then
				if (cfg.AltPower.now>0 and lib.GetAura({"Rip"})>lib.GetSpellCD("Ferocious Bite") and (lib.GetAura({"Rip"})-3)<=lib.GetSpellCD("Ferocious Bite")) then
					if cfg.talents["Bloodtalons"] and lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
						return lib.SimpleCDCheck("Regrowth")
					else
						return lib.SimpleCDCheck("Ferocious Bite")
					end
				end
			end
			return nil
		end,
		["TF_40"] = function()
			--[[if (lib.Time2Power(40)-cfg.gcd)>math.max(lib.GetSpellCD("Tiger's Fury"),lib.GetAura({"Clearcasting"})) then
				return lib.SimpleCDCheck("Tiger's Fury",lib.GetAura({"Clearcasting"}))
			end]]
			if cfg.Power.now+lib.TimeEnergyGain(math.max(lib.GetSpellCD("Tiger's Fury"),lib.GetAura({"Clearcasting"})))<=20 then
				return lib.SimpleCDCheck("Tiger's Fury",lib.GetAura({"Clearcasting"}))
			end
			return nil
		end,
		["Berserk_TF"] = function()
			--return lib.SimpleCDCheck("Berserk")
			if lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Berserk") then
				return lib.SimpleCDCheck("Berserk",lib.GetAura({"Berserk"}))
			end
			return nil
		end,
		
		
		["Ravage!"] = function()
			if lib.GetLastSpell({"Ravage!"}) then return nil end
			return lib.SimpleCDCheck("Ravage!")
		end,
	
		
		["Swipe"] = function()
			return lib.SimpleCDCheck("Swipe")
			end,
		
		["Shred_OoC"] = function()
			if lib.GetAura({"Clearcasting"})>lib.GetSpellCD("Shred") then
				return lib.SimpleCDCheck("Shred")
			end
			return nil
		end,
--[[		["Rake"] = function()
			if not lib.GetLastSpell({"Rake"}) then
				if lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Rake") then
					return lib.SimpleCDCheck("Rake",(lib.GetAura({"Rake"})-9))
				else
					return lib.SimpleCDCheck("Rake",(lib.GetAura({"Rake"})-2))
				end
			end
			return nil
		end,]]
		
		["FB_Berserk"] = function()
			if cfg.AltPower.now==5 and lib.GetAura({"Rip"})>(5+lib.GetSpellCD("Ferocious Bite")) and lib.GetAuras("Savage Roar")>(3+lib.GetSpellCD("Ferocious Bite")) and lib.GetAura({"Berserk"})>lib.GetSpellCD("Ferocious Bite") then
				return lib.SimpleCDCheck("Ferocious Bite")
			end
			return nil
		end,
		["Ferocious Bite"] = function()
			if cfg.AltPower.now==5 and lib.GetAura({"Rip"})>=(14+lib.GetSpellCD("Ferocious Bite")) and lib.GetAuras("Savage Roar")>=(10+lib.GetSpellCD("Ferocious Bite")) then
				return lib.SimpleCDCheck("Ferocious Bite")
			end
			return nil
		end,
		["FB_biw"] = function()
			if cfg.health<=cfg.bloodinwater and lib.GetAura({"Rip"})>lib.GetSpellCD("Ferocious Bite") then
				if cfg.AltPower.now==5 and lib.GetAuras("Savage Roar")>lib.GetSpellCD("Ferocious Bite") then
					return lib.SimpleCDCheck("Ferocious Bite")
				elseif cfg.AltPower.now>0 then
					return lib.SimpleCDCheck("Ferocious Bite",lib.GetAura({"Rip"})-4)
				end
			end
			return nil
		end,
		["Rip"] = function()
			if cfg.AltPower.now==5 and (lib.GetAura({"Berserk"})>lib.GetSpellCD("Rip") or lib.GetAura({"Rip"})<=lib.GetSpellCD("Tiger's Fury")) then
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-2)
			end
			return nil
		end,
		["Shred_Rip"] = function()
			if lib.GetAura({"Rip"})>0 and cfg.health>25 then
				return lib.SimpleCDCheck("Shred",(lib.GetAura({"Rip"})-4))
			end
			return nil
		end,
		
		
		["Charge"] = function()
			if lib.inrange("Charge") then --and (not lib.inrange("Shred")) 
				return lib.SimpleCDCheck("Charge")
			end
			return nil
		end,
	}

	cfg.plist=cfg.plistdps
	
	lib.SetInterrupt("Kick",{106839})
	
	lib.AddRangeCheck({
	{"Shred",nil},
	{"Kick",{0,0,1,1}}
	--(cfg.talents["Lunar Inspiration"] and {"Moonfire",{1,1,0,1}}),
	})
	
	if cfg.talents["Lunar Inspiration"] then
		lib.AddRangeCheck({{"Moonfire",{1,1,0,1}}})
	end

	
	return true
end

lib.classpostload["DRUID"] = function()
	
	lib.AddSpell("Wrath",{5176}) -- Wrath
	cfg.gcd_spell = "Wrath"
	
	
	--lib.AddAura("Instincts",61336,"buff","player") -- Instincts
	
	--lib.AddAura("Barkskin",22812,"buff","player") -- Barkskin
	
	lib.AddSpell("Mark",{1126}) -- Mark of the Wild
	cfg.case["Mark_nobuff"] = function()
		return lib.SimpleCDCheck("Mark",math.min(lib.GetAuras("Stats"),lib.GetAuras("Versatility")))
	end
	
	
	
	
	
	--lib.AddSpell("Berserk",{106952}) -- Berserk

	
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Rage of the Sleeper")
		lib.CDadd("Frenzied Regeneration")
		lib.CDadd("Maul")
		lib.CDadd("Ironfur")
		lib.CDadd("Mark of Ursol")
		lib.CDadd("Regrowth")
		lib.CDadd("Prowl")
		lib.CDadd("Instincts")
		lib.CDturnoff("Instincts")
		lib.CDadd("Barkskin")
		lib.CDturnoff("Barkskin")
		lib.CDadd("Brutal Slash")
		lib.CDadd("Ashamane's Frenzy")
		lib.CDadd("Berserk")
		lib.CDadd("Elune's Guidance")
		lib.CDadd("Tiger's Fury")
	end
end
end
